#include <string.h>
#include <stdio.h>

typedef unsigned char bool;

#define TRUE 1
#define FALSE 0

#ifndef STREENODE_H
#define STREENODE_H
#define MAXCHILDREN 4

typedef enum 
{
    n_id,
    n_class,
    n_fdec,
    n_constrdec,
    n_methdec,
    n_paramdec,
    n_vardec,
    n_empty,
	n_expr,
    n_ret,
    n_cond,
    n_while,
    n_assign,
    n_relop,
    n_addop,
    n_mulop,
    n_intval,
    n_doubleval,
    n_stringval,
    n_boolval,
    n_fieldref, /* obj.f */
    n_methcall, /* m(...) = this.m(...) or obj.m(...) */
    n_constrcall,
    n_cast,
    n_this,
    n_new
} NodeType;

struct STreeNode;

typedef struct STreeNode* STreePtr; 

struct STreeNode
{
    NodeType type;
    STreePtr children[MAXCHILDREN];
    STreePtr sibling;
    char* extrainfo;
};


STreePtr Create(NodeType t, STreePtr c0, STreePtr c1, STreePtr c2, STreePtr c3);
STreePtr CreateString(NodeType t, const char *s);
void Destroy(STreePtr n);
STreePtr GetChild(STreePtr n, unsigned int i);
void SetChild(STreePtr n, unsigned int i, STreePtr c);
void SetSibling(STreePtr n, STreePtr c);
void SetLastSibling(STreePtr n, STreePtr c);
void SetExtraInfo(STreePtr n, const char *s);
void Print(STreePtr n, FILE *os, unsigned int indent);
bool HasChildren(STreePtr n);

#endif
